 Program ToFigureDifGrSideRealTimeForTeX ;
 Var
   fr,ft  : Text ;
   tn,tk  : Extended ;
   mx,my  : LongInt ;
   px,py  : LongInt ;
   hx,hy  : LongInt ;
   am,bm  : Extended ;
   tc,ac  : Extended ;
   xm,ym  : Extended ;
   xs,ys  : Extended ;
 Begin
   Assign(fr,'gsrtime.prt'); { file with the numbers }
   ReSet(fr);
   tn:=+1.0e10;
   tk:=-1.0e10;
   am:=+1.0e10;
   bm:=-1.0e10;
   While  NOT EOF(fr)  Do
     Begin
       ReadLn(fr,tc,ac);
       ac:=1.0e3*ac; { in milli arc second }
       If  tc < tn  Then  tn:=tc; { initial moment }
       If  tc > tk  Then  tk:=tc; { finish moment }
       If  ac < am  Then  am:=ac; { minimum }
       If  ac > bm  Then  bm:=ac; { maximum }
     End;
   ym:=Abs(am);
   If  bm > ym  Then  ym:=bm; { maximum on half y }
   WriteLn('start and finish on time',tn:15:2,tk:15:2);
   WriteLn('minimum and maximum',am:12:6,bm:12:6);
   mx:=300; { area on x }
   my:=200; { area on y }
   hx:=10; { the initial nullo point }
   hy:=my div 2; { for the axes x and y }
   xs:=(mx-5-2*hx)/(tk-tn); { unit scale on x axis }
   ys:=(hy-5)/ym; { unit scale on y axis }
   WriteLn('unit on scale x and y',xs:18:10,ys:18:10);
   Assign(ft,'iaur04f3.tex'); { file with the TeX commands }
   ReWrite(ft);
   WriteLn(ft,'\begin{figure}[h]');
   WriteLn(ft,' \begin{center}');
   WriteLn(ft,' \begin{picture}(',(mx+10):3,',',(my+10):3,')'); { area }
   WriteLn(ft,'  \put(',hx:2,',',hy:2,
              '){\vector(1,0){',(mx-2*hx):3,'}}'); { axis OX }
   WriteLn(ft,'  \put(',hx:2,',0',
              '){\vector(0,1){',my:3,'}}'); { axis OY }
   WriteLn(ft,'  \put(',(hx-10):1,',',(hy-4):2,'){0}'); { point 0 }
   WriteLn(ft,'  \put(',(mx-2):3,',',(hy-4):2,
              '){{\bf t} in year}'); { end X }
   WriteLn(ft,'  \put(',(hx-3):1,',',(my+2):3,
              '){$\Delta S_{\oplus}$ in milliarcsecond}'); { end Y }
   WriteLn(ft,'% unit on x axis');
   tc:=tn+1*365.25;
   Repeat
     px:=hx+Round(xs*(tc-tn));
     py:=hy;
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(0,1){5}}'); { on x }
     tc:=tc+1*365.25;
   Until  ( tc > tk+1.0 ) ;
   xm:=0.0;
   tc:=tn+5*365.25;
   Repeat
     px:=hx+Round(xs*(tc-tn));
     py:=hy;
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(0,1){8}}'); { on x }
     If  xm < 9.0
       Then
         Begin
           px:=px-2;
           py:=py+10;
         End
       Else
         Begin
           px:=px-7;
           py:=py-10;
         End;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):1,'}');
     xm:=xm+5.0;
     tc:=tc+5*365.25;
   Until  ( tc > tk+1.0 ) ;
   WriteLn(ft,'% unit on y axis');
   xm:=+10.0;
   ac:=+10.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     px:=px-15;
     py:=py-3;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm+10.0;
     ac:=ac+10.0;
   Until  ac > ym ;
   xm:=-10;
   ac:=-10.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     px:=px-18;
     py:=py-3;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm-10.0;
     ac:=ac-10.0;
   Until  Abs(ac) > ym ;
   WriteLn(ft,'  % point by point');
   ReSet(fr); { to read point by point }
   While  NOT EOF(fr)  Do
     Begin
       ReadLn(fr,tc,ac); { the current point }
       ac:=1.0e3*ac; { in milli arc second }
       px:=hx+Round(xs*(tc-tn)); { point on x }
       py:=hy+Round(ys*ac); { point on y }
       WriteLn(ft,'    \put(',px:1,',',py:1,
                  '){\circle*{2}}');
     End;
   Close(fr);
   WriteLn(ft,' \end{picture}');
   WriteLn(ft,' \end{center}');
   WriteLn(ft,' \caption{⫨ 誠 \" ६}');
   WriteLn(ft,' \label{pfigsrt}');
   WriteLn(ft,'\end{figure}');
   Close(ft);
 End.