 Program ToFigureXYPoleModelForTeX ;
 Var
   fr,ft  : Text ;
   tn,tk  : Extended ;
   mx,my  : LongInt ;
   px,py  : LongInt ;
   hx,hy  : LongInt ;
   am,bm  : Extended ;
   tc,pc  : Extended ;
   ax,ay  : Extended ;
   bx,by  : Extended ;
   xm,ym  : Extended ;
   xs,ys  : Extended ;
   ac     : Extended ;
 Begin
   Assign(fr,'xpyp.prt'); { file with the numbers }
   ReSet(fr);
   tn:=+1.0e10;
   tk:=-1.0e10;
   am:=+1.0e10;
   bm:=-1.0e10;
   pc:=0; { numer of point }
   While  NOT EOF(fr)  Do
     Begin
       ReadLn(fr,tc,ax,ay,bx,by);
       pc:=pc+1;
       ax:=1.0e3*ax; { in micro arc second }
       ay:=1.0e3*ay; { in micro arc second }
       bx:=1.0e3*bx; { in micro arc second }
       by:=1.0e3*by; { in micro arc second }
       If  tc < tn  Then  tn:=tc; { initial moment }
       If  tc > tk  Then  tk:=tc; { finish moment }
       If  ax < am  Then  am:=ax; { minimum }
       If  ax > bm  Then  bm:=ax; { maximum }
       If  ay < am  Then  am:=ay; { minimum }
       If  ay > bm  Then  bm:=ay; { maximum }
     End;
   ym:=Abs(am);
   If  bm > ym  Then  ym:=bm; { maximum on half y }
   WriteLn('start and finish on time',tn:15:2,tk:15:2);
   WriteLn('minimum and maximum',am:12:6,bm:12:6);
   mx:=500; { area on x for two scales 2 * 240 }
   my:=200; { area on y }
   hx:=10; { the initial nullo point }
   hy:=my div 2; { for the axes x and y }
   xs:=((mx div 2)-2*hx-10)/pc; { unit scale on x axis , pc number of point }
   ys:=(hy-5)/ym; { unit scale on y axis }
   WriteLn('unit on scale x and y',xs:18:10,ys:18:10);
   Assign(ft,'iaur04f4.tex'); { file with the TeX commands }
   ReWrite(ft);
   WriteLn(ft,'\begin{figure}[h]');
   WriteLn(ft,' \begin{center}');
   WriteLn(ft,' \begin{picture}(',(mx+10):3,',',(my+10):3,')'); { area }
   WriteLn(ft,'  \put(',hx:2,',',hy:2, { the first axis OX }
              '){\vector(1,0){',((mx div 2)-2*hx):3,'}}');
   WriteLn(ft,'  \put(',hx:2,',0',
              '){\vector(0,1){',my:3,'}}'); { axis OY }
   WriteLn(ft,'  \put(',(hx-10):1,',',(hy-4):2,'){0}'); { point 0 }
(*
   WriteLn(ft,'  \put(',(mx-2):3,',',(hy-4):2,
              '){{\bf t} in year}'); { end X }
*)
   WriteLn(ft,'  \put(',(hx-3):1,',',(my+2):3,
              '){${\bf x_p}$ in microarcsecond}'); { end Y }
   WriteLn(ft,'  \put(',((mx div 2)+hx):2,',',hy:2, { the second axis OX }
              '){\vector(1,0){',((mx div 2)-2*hx):3,'}}');
   WriteLn(ft,'  \put(',((mx div 2)+hx):2,',0',
              '){\vector(0,1){',my:3,'}}'); { axis OY }
   WriteLn(ft,'  \put(',((mx div 2)+hx-10):1,',',(hy-4):2,'){0}'); { point 0 }
   WriteLn(ft,'  \put(',(mx-2):3,',',(hy-4):2,
              '){{\bf t}}'); { end X }
   WriteLn(ft,'  \put(',((mx div 2)+hx-3):1,',',(my+2):3,
              '){${\bf y_p}$ in microarcsecond}'); { end Y }
   WriteLn(ft,'% unit on the first x axis');
   tc:=20;
   Repeat
     px:=hx+Round(xs*tc);
     py:=hy;
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(0,1){5}}'); { on x }
     tc:=tc+20;
   Until  ( tc > pc ) ;
   WriteLn(ft,'% unit on the second x axis');
   tc:=20;
   Repeat
     px:=(mx div 2)+hx+Round(xs*tc);
     py:=hy;
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(0,1){5}}'); { on x }
     tc:=tc+20;
   Until  ( tc > pc ) ;
   WriteLn(ft,'% unit on the first y axis');
   ac:=+100.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     ac:=ac+100.0;
   Until  ac > ym ;
   ac:=-100.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     ac:=ac-100.0;
   Until  Abs(ac) > ym ;
   xm:=+500.0;
   ac:=+500.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){5}}'); { on y }
     px:=px+8;
     py:=py-3;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm+500.0;
     ac:=ac+500.0;
   Until  ac > ym ;
   xm:=-500.0;
   ac:=-500.0;
   Repeat
     px:=hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){5}}'); { on y }
     px:=px+8;
     py:=py-4;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm-500.0;
     ac:=ac-500.0;
   Until  Abs(ac) > ym ;
   WriteLn(ft,'% unit on the second y axis');
   ac:=+100.0;
   Repeat
     px:=(mx div 2)+hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     ac:=ac+100.0;
   Until  ac > ym ;
   ac:=-100.0;
   Repeat
     px:=(mx div 2)+hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){3}}'); { on y }
     ac:=ac-100.0;
   Until  Abs(ac) > ym ;
   xm:=+500.0;
   ac:=+500.0;
   Repeat
     px:=(mx div 2)+hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){5}}'); { on y }
     px:=px+8;
     py:=py-3;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm+500.0;
     ac:=ac+500.0;
   Until  ac > ym ;
   xm:=-500.0;
   ac:=-500.0;
   Repeat
     px:=(mx div 2)+hx;
     py:=hy+Round(ys*ac);
     WriteLn(ft,'   \put(',px:1,',',py:1,'){\line(1,0){5}}'); { on y }
     px:=px+8;
     py:=py-4;
     WriteLn(ft,'    \put(',px:1,',',py:1,'){',Round(xm):2,'}');
     xm:=xm-500.0;
     ac:=ac-500.0;
   Until  Abs(ac) > ym ;
   WriteLn(ft,'  % point by point');
   ReSet(fr); { to read point by point }
   pc:=0.0;
   While  NOT EOF(fr)  Do
     Begin
       ReadLn(fr,tc,ax,ay,bx,by); { the current point }
       pc:=pc+1;
       ax:=1.0e3*ax; { in micro arc second }
       ay:=1.0e3*ay; { in micro arc second }
       bx:=1.0e3*bx; { in micro arc second }
       by:=1.0e3*by; { in micro arc second }
       px:=hx+Round(xs*pc); { point on the first x }
       py:=hy+Round(ys*ax); { point on the first y tide }
       WriteLn(ft,'    \put(',px:1,',',py:1,
                  '){\circle*{2}}');
       py:=hy+Round(ys*bx); { point on the first y nutation }
       WriteLn(ft,'    \put(',px:1,',',py:1,
                  '){\circle*{2}}');
       px:=(mx div 2)+hx+Round(xs*pc); { point on the second x }
       py:=hy+Round(ys*ay); { point on the second y tide }
       WriteLn(ft,'    \put(',px:1,',',py:1,
                  '){\circle*{2}}');
       py:=hy+Round(ys*by); { point on the second y nutation }
       WriteLn(ft,'    \put(',px:1,',',py:1,
                  '){\circle*{2}}');
     End;
   Close(fr);
   WriteLn(ft,' \end{picture}');
   WriteLn(ft,' \end{center}');
   WriteLn(ft,' \caption{᪠   }');
   WriteLn(ft,' \label{pfxypole}');
   WriteLn(ft,'\end{figure}');
   Close(ft);
 End.