
 UNIT UnForApp ; { some parameters for Chebyshev approximation process }

 INTERFACE

 Const
   MaxPolM  = 21 ;

 Var
   polc    : Array [1..MaxPolM+1] of Extended ;
   xuzpo   : Array [1..MaxPolM+2] Of Extended ;
   polcpo  : Array [1..MaxPolM+1,1..MaxPolM+2] of Extended ;

 Procedure ClcChebPol ( m  : Byte ; x  : Extended ) ;

 Procedure ClcChebPolinPoints ( MPol  : Byte ) ;

 IMPLEMENTATION

 { to calculate Chebyshev polinoms }

 Procedure ClcChebPol ( m  : Byte ; x  : Extended ) ;
 Var
   i    : Byte ;
 Begin
   polc[1]:=1;
   polc[2]:=x;
   For i:=2 To m Do
     polc[i+1]:=2*x*polc[i]-polc[i-1];
 End;

 { to calculate the values of the Chebyshev polinoms
      in the selected points }

 Procedure ClcChebPolinPoints ( MPol  : Byte ) ;
 Var
   i,j,k  : Byte;
   po,uz  : Extended;
 Begin
   po:=Pi/(MPol+1.0e0);
   For k:=1 To MPol+1 Do
     Begin
       polc[k]:=0;
       For i:=1 To MPol+2 Do
         Begin
           If  k = 1  Then  xuzpo[i]:=0;
           polcpo[k,i]:=0;
         End;
     End;
   For i:=1 To MPol+2 Do
     Begin
       j:=MPol+2-i;
       uz:=Cos(j*po);
       ClcChebPol(MPol,uz);
       For k:=1 To MPol+1 Do  polcpo[k,i]:=polc[k];
       xuzpo[i]:=uz;
     End;
 End;

 END.