 { simple type for right hand side of equations }
 UNIT UnForTyp ;
 INTERFACE
 Uses
   UnConTyp ;
 Const
   NumberOfCoor  = 3 ;
   NumberOfVar   = 6 ;
 Type
   TVarSix   = Array [1..NumberOfVar] of Extended ;
 Const
   IndTime   : Byte = 1 ; { 1 for utc , 2 for tt , 3 for teph }
 Type
   TDatTime  = Record { three scale of time in one record }
                 utc,ut1,tt,teph  : Extended ;
               End;
   TIntTime  = Record { it is convenient for integration process }
                 begday  : Extended ; { start value for time in day }
                 cursec  : Extended ; { current value for time in second }
               End;
   TDatPole  = Record { current value of Earth rotation parameters }
                 utc,dut,xpo,ypo,dxe,dye  : Extended ;
               End;
 Var
   NumFVar   : Byte ; { for variant of the right hand side }
   TerSelM   : TMatr33 ; { matrix from TRS to CRS }
   SelTerM   : TMatr33 ; { matrix from CRS to TRS }
 Var
   DatTime   : TDatTime ;
   IntTime   : TIntTime ;
 Const
   DatPole   : TDatPole = { current value of Earth rotation parameters }
               ( utc  : 2451545.0 ; { moment in julian day }
                 dut  : 0.0 ; { UT1-UTC }
                 xpo  : 0.0 ; { empiric value x TRS pole position }
                 ypo  : 0.0 ; { empiric value y TRS pole position }
                 dxe  : 0.0 ; { empiric value delta(X) for CRS pole }
                 dye  : 0.0 ) ; { empiric value delta(Y) for CRS pole }
 IMPLEMENTATION
 END.
