
 { to obtain Earth rotation parameters from the known source }

 UNIT UnGetERP ;

 INTERFACE

 Uses
   UnForTyp ;

 Const
   BooERP   :  Boolean = FALSE ;

 Var
   ERPFile  : Text ;

 Procedure ToOpenERPFile ;

 Procedure ToCloseERPFile ;

 Procedure ToObtainERParm ( ut  : Extended ;  Var  dp : TDatPole ) ;

 IMPLEMENTATION

 Procedure ToOpenERPFile ;
 Begin
   BooERP:=FALSE;
 End;

 Procedure ToCloseERPFile ;
 Begin
   If  BooERP  Then  Close(ERPFile) ;
 End;

 { ut is moment in julian day
   result is in variable dp of TDatPole type
   TDatPole.(utc,dut,xpo,ypo,dxe,dye)
   dut - UT1-UTC
   xpo - empiric value x TRS pole position
   ypo - empiric value y TRS pole position
   dxe - empiric value delta(X) for CRS pole
   dye - empiric value delta(Y) for CRS pole }

 Procedure ToObtainERParm ( ut  : Extended ;  Var  dp : TDatPole ) ;
 Begin
   With  dp  Do
     If  NOT BooERP
       Then
         Begin
           dut:=0.0 ; { UT1-UTC }
           xpo:=0.0 ; { empiric value x TRS pole position }
           ypo:=0.0 ; { empiric value y TRS pole position }
           dxe:=0.0 ; { empiric value delta(X) for CRS pole }
           dye:=0.0 ; { empiric value delta(Y) for CRS pole }
         End
       Else
         Begin
           { to read ERPfile if possible }
         End;
 End;

 END.
