
 { to calculate Q(t) matrix with the use value for X Y and s(t)
                R(-theta) matrix with the use linear formulae for theta }

 UNIT UnQM2000 ;

 INTERFACE

 Uses
   UnConTyp ; { for types and constants }

 Procedure QMatr2000 ( DateJulian  : Extended ;
                       DeltaXEmp   : Extended ; { delta(X) , delta(Y) }
                       DeltaYEmp   : Extended ; { empiric value in arcsec }
                       Var  QMatr  : TMatr33  ) ;

 Procedure QRMatr2000 ( DateJulian   : Extended ;
                        DateJulUT1   : Extended ;
                        DeltaXEmp    : Extended ;
                        DeltaYEmp    : Extended ;
                        Var  QRMatr  : TMatr33  ) ;

 IMPLEMENTATION

 Uses
   UnXY2000 , Un2000_S , Un2000_r , UnForFun ;

 { to calculate Q(t) matrix 
   Q(t)=q(X,Y)*z(+s) with the use value for X Y and s(t) }

 Procedure QMatr2000 ( DateJulian  : Extended ; { moment of time }
                       DeltaXEmp   : Extended ; { delta(X) , delta(Y) }
                       DeltaYEmp   : Extended ; { empiric value in arcsec }
                       Var  QMatr  : TMatr33  ) ;
 Var
   d,s  : Extended ;
   x,y  : Extended ;
   q,z  : TMatr33 ;
   x2,y2,aa,cd  : Extended ;
 Begin
   d:=DateJulian; { date in Julian Day }
   FormulaeXY(d,x,y); { XCip , YCip in radian , pole position }
   x:=x+SecRad*DeltaXEmp; { with empirical correction }
   y:=y+SecRad*DeltaYEmp; { with empirical correction }
   x2:=Sqr(x); { x*x }
   y2:=Sqr(y); { y*y }
   cd:=Sqrt(1-(x2+y2)); { z=cos(d) , x y z is unit vector }
   aa:=1.0/(1+cd);
   q[1,1]:=+1-aa*x2;
   q[1,2]:=-aa*x*y;
   q[1,3]:=+x;
   q[2,1]:=-aa*x*y;
   q[2,2]:=+1-aa*y2;
   q[2,3]:=+y;
   q[3,1]:=-x;
   q[3,2]:=-y;
   q[3,3]:=+1-aa*(x2+y2); { this is part of Q(t) matrix }
   s:=SecRad*ToGetCEOPos(d,x,y); { a value for s(t) CEO position to radian }
   ForRotMatr(3,s,z); { to rotate about z-axis on the angle s(t) in radian }
   ToMultMatr(q,z,QMatr); { full Q(t) matrix }
 End;

 { to multiplicate Q(t) and R(t) matrixes
   from the equator of the CIP to the fixed equator GCRS }

 Procedure QRMatr2000 ( DateJulian   : Extended ;
                        DateJulUT1   : Extended ;
                        DeltaXEmp    : Extended ;
                        DeltaYEmp    : Extended ;
                        Var  QRMatr  : TMatr33  ) ;
 Var
   QMatr,RMatr  : TMatr33 ;
 Begin
   RMatr2000(DateJulUT1,RMatr);
   QMatr2000(DateJulian,DeltaXEmp,DeltaYEmp,QMatr);
   ToMultMatr(QMatr,RMatr,QRMatr); { full Q(t)*R(-theta) matrix }
 End;

 END.
