
 { some simple procedure
   IAU 2000resolution B1.5 B1.3 }

 UNIT UnRelat ;

 INTERFACE

 Uses
   UnConTyp ;

 Function ToGetTIntPartOne ( DateJulian  : Extended ) : Extended ;

 Function ToGetTIntPartTwo ( DateJulian  : Extended ) : Extended ;

 Function ToGetTVelPartOne ( d  : Extended ;  r  : TVect3 ) : Extended ;

 Function ToGetTVelPartTwo ( d  : Extended ;  r  : TVect3 ) : Extended ;

 Procedure ForPosCorrection ( d  : Extended ;
                              r  : TVect3 ;
                              Var  rc  : TVect3 ) ;

 IMPLEMENTATION

 Uses
   UnEphJPL ;

 Function ToGetTIntPartOne ( DateJulian  : Extended ) : Extended ;
 Var
   n  : Byte ;
   a  : Extended ;
   d  : Extended ;
   r  : Extended ;
   u  : Extended ;
   w  : Extended ;
   p  : Array [1..NumberOfPlanets] of TVect3 ;
   v  : Array [1..NumberOfPlanets] of TVect3 ;
 Begin
   d:=DateJulian ;
   For n:=1 To NumberOfPlanets Do
     If  NOT ( n IN [ NEarth , NMoon ] )
       Then
         ClcPosVel(n,d,p[n],v[n]);       { reffered }
   ClcEphEarth(d,p[NEarth],v[NEarth]); { to barycenter }
   ClcEphMoon(d,p[NMoon],v[NMoon]);    { of the Solar system }
   u:=Sqrt(Sqr(v[NEarth][1])+Sqr(v[NEarth][2])+Sqr(v[NEarth][3]));
   u:=Sqr(u/VelOfLight);
   w:=0;
   For n:=1 To NumberOfPlanets Do
     If  n <> NEarth
       Then
         Begin
           r:=Sqrt(Sqr(p[n][1]-p[NEarth][1])
                  +Sqr(p[n][2]-p[NEarth][2])+Sqr(p[n][3]-p[NEarth][3]));
           w:=w+FactorMuEachPlanet[n]/r;
         End;
   a:=0.5*u+w/Sqr(VelOfLight);
   ToGetTIntPartOne:=a/(1-1.5505e-8);
 End;

 Function ToGetTIntPartTwo ( DateJulian  : Extended ) : Extended ;
 Var
   n  : Byte ;
   i  : Byte ;
   a  : Extended ;
   d  : Extended ;
   r  : Extended ;
   u  : Extended ;
   w  : Extended ;
   z  : Extended ;
   q  : TVect3 ;
   p  : Array [1..NumberOfPlanets] of TVect3 ;
   v  : Array [1..NumberOfPlanets] of TVect3 ;
 Begin
   d:=DateJulian ;
   For n:=1 To NumberOfPlanets Do
     If  NOT ( n IN [ NEarth , NMoon ] )
       Then
         ClcPosVel(n,d,p[n],v[n]);       { reffered }
   ClcEphEarth(d,p[NEarth],v[NEarth]); { to barycenter }
   ClcEphMoon(d,p[NMoon],v[NMoon]);    { of the Solar system }
   u:=Sqrt(Sqr(v[NEarth][1])+Sqr(v[NEarth][2])+Sqr(v[NEarth][3]));
   u:=Sqr(u/VelOfLight);
   w:=0;
   For i:=1 To 3 Do  q[i]:=0;
   For n:=1 To NumberOfPlanets Do
     If  n <> NEarth
       Then
         Begin
           r:=Sqrt(Sqr(p[n][1]-p[NEarth][1])
                  +Sqr(p[n][2]-p[NEarth][2])+Sqr(p[n][3]-p[NEarth][3]));
           r:=FactorMuEachPlanet[n]/(r*Sqr(VelOfLight));
           w:=w+r;
           For i:=1 To 3 Do
             q[i]:=q[i]+v[n][i]*r;
         End;
   z:=0;
   For i:=1 To 3 Do  z:=z+v[NEarth][i]*q[i];
   a:=-0.125*Sqr(u)-1.5*u*w+4*z/Sqr(VelOfLight)+0.5*Sqr(w);
   ToGetTIntPartTwo:=a;
 End;

 Function ToGetTVelPartOne ( d  : Extended ;  r  : TVect3 ) : Extended ;
 Var
   p  : TVect3 ;
   v  : TVect3 ;
 Begin
   ClcEphEarth(d,p,v); { to barycenter }
   ToGetTVelPartOne:=(v[1]*r[1]+v[2]*r[2]+v[3]*r[3])/Sqr(VelOfLight);
 End;

 Function ToGetTVelPartTwo ( d  : Extended ;  r  : TVect3 ) : Extended ;
 Var
   i  : Byte ;
   n  : Byte ;
   q  : Extended ;
   u  : Extended ;
   w  : Extended ;
   z  : Extended ;
   p  : Array [1..NumberOfPlanets] of TVect3 ;
   v  : Array [1..NumberOfPlanets] of TVect3 ;
 Begin
   For n:=1 To NumberOfPlanets Do
     If  NOT ( n IN [ NEarth , NMoon ] )
       Then
         ClcPosVel(n,d,p[n],v[n]);       { reffered }
   ClcEphEarth(d,p[NEarth],v[NEarth]); { to barycenter }
   ClcEphMoon(d,p[NMoon],v[NMoon]);    { of the Solar system }
   u:=Sqrt(Sqr(v[NEarth][1])+Sqr(v[NEarth][2])+Sqr(v[NEarth][3]));
   u:=Sqr(u/VelOfLight);
   w:=0;
   For n:=1 To NumberOfPlanets Do
     If  n <> NEarth
       Then
         Begin
           q:=Sqrt(Sqr(p[n][1]-p[NEarth][1])
                  +Sqr(p[n][2]-p[NEarth][2])+Sqr(p[n][3]-p[NEarth][3]));
           w:=w+FactorMuEachPlanet[n]/q;
         End;
   q:=-0.5*u-3*w/Sqr(VelOfLight);
   z:=0;
   For i:=1 To 3 Do  z:=z+v[NEarth][i]*r[i];
   ToGetTVelPartTwo:=q*z/Sqr(VelOfLight);
 End;

 Procedure ForPosCorrection ( d  : Extended ;
                              r  : TVect3 ;
                              Var  rc  : TVect3 ) ;
 Var
   i  : Byte ;
   n  : Byte ;
   a  : TVect3 ;
   q  : Extended ;
   w  : Extended ;
   x  : Extended ;
   z  : Extended ;
   p  : Array [1..NumberOfPlanets] of TVect3 ;
   v  : Array [1..NumberOfPlanets] of TVect3 ;
 Begin
   For n:=1 To NumberOfPlanets Do
     If  NOT ( n IN [ NEarth , NMoon ] )
       Then
         ClcPosVel(n,d,p[n],v[n]);       { reffered }
   ClcEphEarth(d,p[NEarth],v[NEarth]); { to barycenter }
   ClcAccEarth(d,a); { acceleration for the Earth in km/s**2 }
   ClcEphMoon(d,p[NMoon],v[NMoon]);    { of the Solar system }
   w:=0;
   For n:=1 To NumberOfPlanets Do
     If  n <> NEarth
       Then
         Begin
           q:=Sqrt(Sqr(p[n][1]-p[NEarth][1])
                  +Sqr(p[n][2]-p[NEarth][2])+Sqr(p[n][3]-p[NEarth][3]));
           w:=w+FactorMuEachPlanet[n]/(q*Sqr(VelOfLight));
         End;
   q:=(a[1]*r[1]+a[2]*r[2]+a[3]*r[3])/Sqr(VelOfLight);
   n:=NEarth;
   z:=(v[n][1]*r[1]+v[n][1]*r[1]+v[n][1]*r[1])/Sqr(VelOfLight);
   x:=(Sqr(r[1])+Sqr(r[2])+Sqr(r[3]))/Sqr(VelOfLight);
   For i:=1 To 3 Do
     rc[i]:=0.5*z*v[NEarth][i]+(w+q)*r[i]-0.5*x*a[i];
 End;

 END.
