
 { to obtain
   some relativistic potentials
   in post-newtonian approximation
   with the use planets ephemeris
   there are two way
    isotropic coordinate condition
     harmonic coordinate condition }
   

 UNIT UnRelPot ;

 INTERFACE

 Procedure ForDifference ;

 IMPLEMENTATION

 Uses
   UnConTyp , { type and constant }
   UnEphJPL , { position and velosity of the planets }
   UnForFun ; { ScalarMult for example }

 Var
   p  : Array [1..NumberOfPlanets] of TVect3 ; { position in km }
   v  : Array [1..NumberOfPlanets] of TVect3 ; { velosity in km/s }

 { to obtain at the moment d in julian date
   position (p in km) and velosity (v in km/s) of the all planetes }

 Procedure ForAllPosVel ( d  : Extended ) ;
 Var
   n  : Byte ;
 Begin
   For n:=1 To NumberOfPlanets Do { from  UnEphJPL unit }
     If  NOT ( n IN [ NEarth , NMoon ] )
       Then  { all planets position and velosity }
         ClcPosVel(n,d,p[n],v[n]); { at the moment  d }
   ClcEphEarth(d,p[NEarth],v[NEarth]); { reffered o barycenter }
   ClcEphMoon(d,p[NMoon],v[NMoon]);    { of the Solar system }
 End;

 { to obtain at the moment  d  in julian date
   newton potential for planet number k from the other planets
   position and velosity for all planets must be in massives p and v }

 Function PotForOneP ( k  : Byte ) : Extended ;
 Var
   n  : Byte ;
   r  : Extended ;
   q  : Extended ;
 Begin
   q:=0.0;
   For n:=1 To NumberOfPlanets Do
     If  n <> k
       Then
         Begin
           r:=Sqrt(Sqr(p[n][1]-p[k][1])
                  +Sqr(p[n][2]-p[k][2])+Sqr(p[n][3]-p[k][3])); { km }
           If  Abs(r) > 1.0
             Then { without thrust }
               q:=q+FMPlanet[n]/r; { km^2/s^2 }
         End;
   PotForOneP:=q; { potential for one planet in km^2/s^2 }
 End;

 { to obtain newton potential
   for the any point of space
   in the solar barycentric system
   position and velosity for all planets must be in massives p and v }

 Function PotNewtonU ( a  : TVect3 ) : Extended ;
 Var
   n  : Byte ;
   r  : Extended ;
   q  : Extended ;
 Begin
   q:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
              +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           q:=q+FMPlanet[n]/r;
     End;
   PotNewtonU:=q; { km^2/s^2 }
 End;

 { scalar potential W with isotropic coordinate condition
   a[3] for position of the body }

 Function PotScalarIsotropic ( a  : TVect3 ) : Extended ;
 Var
   n  : Byte ;
   r  : Extended ;
   z  : Extended ;
   w  : Extended ;
 Begin
   w:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
              +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           Begin
             z:=Sqr(v[n][1])+Sqr(v[n][2])+Sqr(v[n][3]); { km^2/s^2 }
             z:=1.5*z-PotForOneP(n); { km^2/s^2 }
             w:=w+FMPlanet[n]*z/r; { km^2/s^2 * km^2/s^2 for c^2}
           End;
     End;
   PotScalarIsotropic:=w; { km^2/s^2 * km^2/s^2 one for c^2}
 End;

 { to obtain one planet number k acceleration
   due to attraction with the other planetes }

 Procedure ForceOneP ( k  : Byte ; Var  f  : TVect3 ) ;
 Var
   i  : Byte ;
   n  : Byte ;
   r  : Extended ;
   z  : Extended ;
 Begin
   For i:=1 To 3 Do  f[i]:=0.0;
   For n:=1 To NumberOfPlanets Do
     If  n <> k
       Then
         Begin
           r:=Sqrt(Sqr(p[n][1]-p[k][1])
                  +Sqr(p[n][2]-p[k][2])+Sqr(p[n][3]-p[k][3])); { km }
           If  Abs(r) > 1.0
             Then { without thrust }
               Begin
                 z:=FMPlanet[n]/(r*Sqr(r)); { 1/s^2 }
                 For i:=1 To 3 Do
                   f[i]:=f[i]+z*(p[k][i]-p[n][i]); { km/s^2 , the forces }
               End;
         End;
 End;

 { to obtain acceleration of a body 
   due to attraction with the all planetes
   a[3]  position vector of the body in km }

 Procedure ForceNewton ( a  : TVect3 ; Var  f  : TVect3 ) ;
 Var
   i  : Byte ;
   n  : Byte ;
   r  : Extended ;
   z  : Extended ;
 Begin
   For i:=1 To 3 Do  f[i]:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
               +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           Begin
             z:=FMPlanet[n]/(r*Sqr(r)); { (km^3/s^2)/km^3 = 1/s^2 }
             For i:=1 To 3 Do
               f[i]:=f[i]+z*(a[i]-p[n][i]); { km/s^2 , the forces }
           End;
     End;
 End;

 { scalar potential W with harmonic coordinate condition
   a[3] for position of the body }

 Function PotScalarHarmonic ( a  : TVect3 ) : Extended ;
 Var
   n  : Byte ;
   r  : Extended ;
   x  : Extended ;
   y  : Extended ;
   z  : Extended ;
   w  : Extended ;
   f  : TVect3 ;
 Begin
   w:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
              +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           Begin
             x:=(p[n][1]-a[1])*v[n][1]
               +(p[n][2]-a[2])*v[n][2]+(p[n][3]-a[3])*v[n][3]; { km^2/s }
             ForceOneP(n,f); { km/s^2 }
             y:=(p[n][1]-a[1])*f[1]
               +(p[n][2]-a[2])*f[2]+(p[n][3]-a[3])*f[3]; { km^2/s^2 }
             z:=Sqr(v[n][1])+Sqr(v[n][2])+Sqr(v[n][3]); { km^2/s^2}
             z:=2*z-PotForOneP(n)-0.5*y-0.5*Sqr(x/r); { km^2/s^2 }
             w:=w+FMPlanet[n]*z/r; { km^2/s^2 * km^2/s^2 }
           End;
     End;
   PotScalarHarmonic:=w; { km^2/s^2 * km^2/s^2 one for c^2 }
 End;

 { a[3] for position of the body , b[3] for result }

 Procedure PotVectorIsotropic ( a  : TVect3 ;  Var  b  : TVect3 ) ;
 Var
   i  : Byte ;
   n  : Byte ;
   r  : Extended ;
   x  : Extended ;
   z  : Extended ;
 Begin
   For i:=1 To 3 Do  b[i]:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
              +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           Begin
             x:=(a[1]-p[n][1])*v[n][1]
               +(a[2]-p[n][2])*v[n][2]+(a[3]-p[n][3])*v[n][3]; { km^2/s }
             x:=x/Sqr(r); { 1/s }
             z:=0.5*FMPlanet[n]/r; { km^2/s^2 }
             For i:=1 To 3 Do
               b[i]:=b[i]+z*(7*v[n][i]+x*(a[i]-p[n][i])); { km^3/s^3 }
           End;
     End;
 End;

 Procedure PotVectorHarmonic ( a  : TVect3 ;  Var  b  : TVect3 ) ;
 Var
   i  : Byte ;
   n  : Byte ;
   r  : Extended ;
   x  : Extended ;
   z  : Extended ;
 Begin
   For i:=1 To 3 Do  b[i]:=0.0;
   For n:=1 To NumberOfPlanets Do
     Begin
       r:=Sqrt(Sqr(p[n][1]-a[1])
              +Sqr(p[n][2]-a[2])+Sqr(p[n][3]-a[3])); { km }
       If  Abs(r) > 1.0
         Then { without thrust }
           Begin
             z:=4*FMPlanet[n]/r; { km^2/s^2 }
             For i:=1 To 3 Do
               b[i]:=b[i]+z*v[n][i]; { km^3/s^3 }
           End;
     End;
 End;

 { to obtain by numeric integration difference in coordinate
   one vector under isotropic condition but harmonic other }

 Procedure ForDifference ;
 Var
   f  : Text ;
   i  : Byte ;
   n  : Byte ;
   m  : Byte ;
   t  : Extended ;
   s  : Extended ;
   w  : Extended ;
   g  : Extended ;
   h  : Extended ;
   y  : Extended ;
   z  : Extended ;
   a  : TVect3 ;
   b  : TVect3 ;
   c  : TVect3 ;
   q  : TVect3 ;
   r  : TVect3 ;
   d  : TVect3 ;
   e  : TVect3 ;
 Begin
   Assign(f,'relpotrc.prt');
   ReWrite(f);
   n:=NEarth;
   w:=Sqr(VelOfLight); { VelOfLight from UnEphJPL , c^2 in km^2/s^2 }
   For i:=1 To 3 Do  d[i]:=0; { differencies for the position variables }
   y:=0; { differencies for the time in second }
   ToGetCoeFileName ; { from UnEphJPL }
   t:=TInitEph+0.5;
   z:=1; { step for integration is one day }
   s:=86400.0*z; { step for integration in second }
   ForAllPosVel(t); { position and velosity for all planetes in p v }
   For i:=1 To 3 Do  a[i]:=p[n][i]; { in km for the selected body }
   PotVectorIsotropic(a,b); { km^3/s^3 }
   PotVectorHarmonic(a,c);  { km^3/s^3 }
   For i:=1 To 3 Do  r[i]:=b[i]-c[i]; { initial km^3/s^3 }
   ForceNewton(a,e); { in km/s^2 }
   h:=PotScalarIsotropic(a)-PotScalarHarmonic(a)
                           -ScalarMult(e,d)*w; { km^4/s^4}
   t:=t+z; { julian day }
   m:=0;
 Repeat
   For i:=1 To 3 Do  q[i]:=r[i]; { km^3/s^3 }
   g:=h; { km^4/s^4 }
   ForAllPosVel(t); { position and velosity for all planetes in p v }
   For i:=1 To 3 Do  a[i]:=p[n][i]; { km }
   PotVectorIsotropic(a,b); { km^3/s^3 }
   PotVectorHarmonic(a,c);  { km^3/s^3 }
   For i:=1 To 3 Do  r[i]:=b[i]-c[i]; { initial  km^3/s^3 }
   For i:=1 To 3 Do
     d[i]:=d[i]+0.5*s*(q[i]+r[i])/w; { km }
   ForceNewton(a,e); { in km/s^2 }
   h:=PotScalarIsotropic(a)-PotScalarHarmonic(a)
                           -ScalarMult(e,d)*w; { km^4/s^4}
   y:=y+0.5*s*(g+h)/Sqr(w);
   m:=m+1;
   If  m = 10
     Then
       Begin
         WriteLn(t:12:2,1.0e3*d[1]:12:3,1.0e3*d[2]:10:3,
                        1.0e3*d[3]:10:3,1.0e12*y:12:3,'    m m m 1e-12s');
         WriteLn(f,t:12:2,1.0e3*d[1]:12:3,1.0e3*d[2]:10:3,
                          1.0e3*d[3]:10:3,1.0e12*y:12:3,'    m m m 1e-12s');
         m:=0;
       End;
   t:=t+z;
 Until  ( t > TLastEph-1 ) ;
   Close(f);
 End;

 END.