
 { to make deal with the procedures
   to transform time-space systems of reference
   external variables from UnForTyp :
   NumFVar , IndTime , DatTime , IntTime , DatPole , TerSelM , SelTerM }

 UNIT UnRotatM ;

 INTERFACE

 Procedure ToObtainRotMats ( tc  : Extended ) ;

 Procedure ToObtainRotMatr ( tc  : Extended ) ;

 IMPLEMENTATION

 Uses
   UnForTyp , { NumFVar , IndTime , DatTime , IntTime , DatPole , TerSelM }
   UnConTyp , { MatrUnit }
   UnForTim , { ToGetUT1 for example }
   UnGetERP , { to obtain empirical Earth rotation parameters }
   Un2000tc ; { matrixes with the IAU2000 resolution }

 { td is moment in julian day
   DatTime of TDatTime , DatPole of TDatPole  are declared in UnForTyp }

 Procedure ToClcTimeValue ( td  : Extended ) ;
 Var
   du  : Extended ; { deltaUT1=UT1-UTC }
   da  : Extended ; { difference TT-UTC }
 Begin
   If  IndTime = 1
     Then { our time scale is UTC in julian day }
       Begin { DatTime.(utc,ut1,tt,teph) in julian day }
         DatTime.utc:=td;
         DatPole.utc:=td;
         du:=DatPole.dut/86400.0; { DatPole.(utc,dut,xpo,...) }
         DatTime.ut1:=ToGetUT1(DatTime.utc,du); { UnForTim }
         FromUTCtoTT(DatTime.utc,DatTime.tt,da); { tt in TT }
         DatTime.teph:=ToGetTEph(DatTime.tt); { Teph }
       End;
 End;

 { tc is moment in second
   from the initial date that is in IntTime.begday
   DatTime.(utc,ut1,tt,teph)
   DatPole.(utc,dut,xpo,ypo,dxe,xye)
   result is in matrixes TerSelM(3,3) SelTerM(3,3) }

 Procedure ToObtainRotMats ( tc  : Extended ) ;
 Var
   td  : Extended ; { current data in julian day with the part }
 Begin
   td:=IntTime.begday+tc/86400.0; { current time in day }
   ToObtainERParm(td,DatPole); { ToGetERP , DatPole in UnForTyp }
   ToClcTimeValue(td); { result to DatTime , DatPole external }
   If  ( ( NumFVar mod 2 ) = 1 )
     Then { for simple changing the reference systems }
       TerraSimpleMatr(td,TerSelM,SelTerM)
     Else { real time real transformation }
       TerraSelestMats(DatTime.tt,DatTime.ut1,
                       DatPole.xpo,DatPole.ypo,
                       DatPole.dxe,DatPole.dye,
                       TerSelM,SelTerM); { procedure from Un2000tc }
 End;

 { more complex then previous procedure
   in TerraSelestMatr
   are obtained theoretical value for x_p y_p
   tc is moment in second
   from the initial date that is in IntTime.begday
   DatTime.(utc,ut1,tt,teph)
   DatPole.(utc,dut,xpo,ypo,dxe,xye)
   result is in matrixes TerSelM(3,3) SelTerM(3,3) }

 Procedure ToObtainRotMatr ( tc  : Extended ) ;
 Var
   td  : Extended ; { current data in julian day with the part }
 Begin
   td:=IntTime.begday+tc/86400.0; { current time in day }
   ToObtainERParm(td,DatPole); { ToGetERP , DatPole in UnForTyp }
   ToClcTimeValue(td); { result to DatTime , DatPole external }
   If  ( ( NumFVar mod 2 ) = 1 )
     Then { for simple changing the reference systems }
       TerraSimpleMatr(td,TerSelM,SelTerM)
     Else { real time real transformation }
       TerraSelestMatr(DatTime.tt,DatTime.ut1,
                       DatPole.xpo,DatPole.ypo,
                       DatPole.dxe,DatPole.dye,
                       TerSelM,SelTerM); { procedure from Un2000tc }
 End;

 END.
